FUNCTION DUS,x,z
;...This module evaluates the radial derivatives
;   of the profiles from the momentum equations
on_error,1

compile_opt hidden
COMMON DUSG,h,alf
COMMON GRAD,vn,d,g,d2vn,d2d,d2g,s

u=z(0) & sg=z(1) & beta=.132653
vz=spl_interp(s,vn,d2vn,x)+sg
dz=spl_interp(s,d,d2d,x)+sg/x
gz=spl_interp(s,g,d2g,x)+sg/x
w=0.8*sqrt(u^2+vz^2) & w=alf*w*(1.+beta*w)

;... radial derivatives from momentum equations
du=-w+sg*gz/u & dsg=-(dz+vz*w/u)
return,[du,dsg]
END ;FUNCTION DUS(x,z)
