PRO SGDVS,cfsg
; This module computes the radial and azimuthal derivatives of sigma

compile_opt hidden
on_error,1

;... preamble
if n_params() eq 0 then begin
print,'SGDVS,cfsg' & return&endif

;... shared memory
COMMON GENSTRE,sstre,csstre,snstre,xnstre,ynstre,vgstre,$
ggstre,ddstre,u0stre,sg0stre,u0dotstre,sg0dotstre
COMMON SGDVS,sgstre,sgdotstre,sgprstre

;...normalization
nrmsg=sqrt(1.+cfsg(0)^2+cfsg(1)^2)

;... form factors
ffsg=(1.+cfsg(0)*csstre+cfsg(1)*snstre)/nrmsg
ffsgpr=(cfsg(1)*csstre-cfsg(0)*snstre)/nrmsg

;... sgstre and its first partial derivatives
sgstre=ffsg*sg0stre
sgdotstre=ffsg*sg0dotstre
sgprstre=ffsgpr*sg0stre
END ;SGDVS.PRO
