PRO UDVS,cfu
; This module computes the radial and azimuthal derivatives of u

compile_opt hidden
on_error,1

;... preamble
if n_params() eq 0 then begin
print,'UDVS,cfu' & return&endif

;... shared memory
COMMON GENSTRE,sstre,csstre,snstre,xnstre,ynstre,vgstre,$
ggstre,ddstre,u0stre,sg0stre,u0dotstre,sg0dotstre
COMMON UDVS,ustre,udotstre,uprstre

;...normalization factor
nrmu=sqrt(1.+cfu(0)^2+cfu(1)^2)

;... form factors
ffu=(1.+cfu(0)*csstre+cfu(1)*snstre)/nrmu
ffupr=(cfu(1)*csstre-cfu(0)*snstre)/nrmu

;... ustre and its first partial derivatives
ustre=ffu*u0stre
udotstre=ffu*u0dotstre
uprstre=ffupr*u0stre
END ;UDVS.PRO
