PRO VGHGEN,s,delp,bhol,fbr,vgr,d2vgr,alp,vgx
;...This module calculates the gradient wind profile
  
compile_opt hidden
on_error,1

;...preamble
if n_params() eq 0 then begin
print,'VGHGEN,s,delp,bhol,fbr,vgr,d2vgr,alp,vgx'
return&endif

;...form normalized modified holland gradient wind profile
info=size(s) & jx=info(1)-1 & vg=s & inz=where(s ne 0.) & gamh=4e2*bhol*delp
vg(inz)=0.4364*(sqrt(gamh/(s(inz)^bhol*exp(1./s(inz)^bhol))+(fbr*s(inz))^2) $
-fbr*s(inz)) & dsvg=deriv(s,vg)

;...gradient wind profile approaches storm center linearly
zzz=s*dsvg-vg & igz=where(zzz ge 0.)
ijoin=max(igz) & alp=0. 
if ijoin gt 0 then alp=0.5*(dsvg(ijoin)+vg(ijoin)/s(ijoin))
vgr=vg & vgr(0:ijoin)=alp*s(0:ijoin)

;...smooth vgr, form non-negative vorticity and recover vgr
for j=1,5 do vgr=smooth(vgr,3) & vgx=max(vgr) & vgr=vgr/vgx
vort=deriv(s,vgr)+vgr/s & vort(0)=vort(1)
ilz=where(vort lt 0.,ict) & if ict ne 0 then vort(ilz)=0.
vgr(0)=0. & itg=0. & for i=1,jx do begin $
itg=itg+s(i)*vort(i)+vort(i-1)*s(i-1) & vgr(i)=itg/s(i) &endfor
vgr=vgr/max(vgr) & d2vgr=spl_init(s,vgr) & fbar=fbr/vgx
END ;VGHGEN.PRO
